<template>
  <div class="toasters">
    <div class="container-fluid">
      <div class="row">
        <div class="col-12 col-md-4 offset-md-4">
          <div class="toaster-list">
            <transition-group name="fade" mode="in-out">
              <div
                class="toaster"
                v-for="toaster in toasters"
                :class="toaster.classes"
                :key="toaster.timestamp"
              >
                <div class="title">
                  <div class="icon">
                    <i :class="toaster.icon"></i>
                  </div>
                  {{ toaster.title }}
                </div>
                <div class="content">
                  {{ toaster.content }}
                </div>
                <div class="timer">
                  <div class="progress"></div>
                </div>
              </div>
            </transition-group>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    name: {
      required: true
    }
  },
  mounted() {
    this.$toasters[this.name] = this;
  },
  data() {
    return {
      toasters: []
    };
  },
  methods: {
    addToaster(content, classes, icon, title, timeout = 2000) {
      const toaster = { timestamp: Date.now(), content, classes, icon, title };
      setTimeout(() => {
        this.toasters.splice(this.toasters.indexOf(toaster), 1);
      }, timeout);
      this.toasters.push(toaster);
    },
    success(content, timeout) {
      this.addToaster(
        content,
        ["toaster-success"],
        ["fas", "fa-check"],
        "Success!",
        timeout
      );
    },
    error(content, timeout) {
      this.addToaster(
        content,
        ["toaster-error"],
        ["fas", "fa-times"],
        "Whoops!",
        timeout
      );
    }
  }
};
</script>

<style lang="scss">
.toasters {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 1000;
  pointer-events: none;
  padding-top: 20px;
  .toaster {
    margin-bottom: 10px;
    position: relative;
    width: 100%;
    background-color: black;
    border-radius: 8px;
    padding: 10px;
    padding-bottom: 10px;
    overflow: hidden;
    box-shadow: 0px 0px 25px 2px rgba(0, 0, 0, 0.18);
    .title {
      display: flex;
      .icon {
        display: flex;
        justify-content: center;
        align-items: center;
      }
      i {
        width: 20px;
      }
    }
    .content {
      font-size: 0.8rem;
    }
    .timer {
      position: absolute;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 5px;
      .progress {
        width: 100%;
        height: 100%;
        position: absolute;
        bottom: 0;
        background-color: white;
        animation-name: progress;
        animation-duration: 2s;
        animation-fill-mode: forwards;
      }
    }
    &.toaster-success {
      background-color: #0dffd6;
      border-color: #00e2c0;
      font-weight: 600;
      .title {
        color: #007b66;
      }
      .content {
        color: #00a28a;
      }
      .progress {
        background-color: #007b66;
      }
    }
    &.toaster-error {
      background-color: #ff4f3f;
      border-color: #bc3b30;
      color: #4b221e;
      font-weight: 600;
      .progress {
        background-color: #b60000;
      }
    }
  }
}
@keyframes progress {
  0% {
    right: 100%;
  }
  100% {
    right: 0;
  }
}
</style>
